<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>InstanceConfigurator xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../apidocs/org/eclipse/papyrus/designer/transformation/extensions/InstanceConfigurator.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*******************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2011 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *     CEA LIST - initial API and implementation</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> *******************************************************************************/</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.transformation.extensions;
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.CoreException;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.IConfigurationElement;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.IExtensionRegistry;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.Platform;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.profile.Deployment.UseInstanceConfigurator;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.InstanceSpecification;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Property;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <em class="jxr_javadoccomment"> * Support for the configuration of instances via the Eclipse extension mechanism</em>
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../org/eclipse/papyrus/designer/deployment/profile/Deployment/InstanceConfigurator.html">InstanceConfigurator</a> {
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String IINSTANCE_CONFIG_ID = Activator.PLUGIN_ID + <span class="jxr_string">".instanceConfig"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> onNodeModel = false;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <em class="jxr_javadoccomment">	 * Configure an instance with a given configurator</em>
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <em class="jxr_javadoccomment">	 * @param useInstanceConfigurator</em>
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <em class="jxr_javadoccomment">	 * @param instance</em>
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <em class="jxr_javadoccomment">	 * @param componentPart</em>
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <em class="jxr_javadoccomment">	 * @param containerContext</em>
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> configureInstance(<a href="../../../../../../org/eclipse/papyrus/designer/deployment/profile/Deployment/UseInstanceConfigurator.html">UseInstanceConfigurator</a> useInstanceConfigurator, InstanceSpecification instance, Property componentPart, InstanceSpecification parentInstance) {
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  		<strong class="jxr_keyword">if</strong> (useInstanceConfigurator != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  			org.eclipse.papyrus.designer.deployment.profile.Deployment.InstanceConfigurator instanceConfigurator =
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  					useInstanceConfigurator.getConfigurator();
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  			<strong class="jxr_keyword">if</strong> (instanceConfigurator.isOnNodeModel() == onNodeModel) {
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  				<strong class="jxr_keyword">if</strong> (instanceConfigurator != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  					String id = instanceConfigurator.getBase_Class().getName();
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  					IInstanceConfigurator iConfigurator = getInstanceConfigurator(id);
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  					<strong class="jxr_keyword">if</strong> (iConfigurator != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  						iConfigurator.configureInstance(instance, componentPart, parentInstance);
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  					}
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  				}
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  			}
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  		}
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  	}
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../../../org/eclipse/papyrus/designer/transformation/extensions/IInstanceConfigurator.html">IInstanceConfigurator</a> getInstanceConfigurator(String iConfiguratorID) {
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  		IExtensionRegistry reg = Platform.getExtensionRegistry();
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  		IConfigurationElement[] configElements = reg.getConfigurationElementsFor(IINSTANCE_CONFIG_ID);
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  		<strong class="jxr_keyword">for</strong> (IConfigurationElement configElement : configElements) {
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  			<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  				<strong class="jxr_keyword">final</strong> String iConfiguratorIDext = configElement.getAttribute(<span class="jxr_string">"configuratorID"</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  				<strong class="jxr_keyword">if</strong> (iConfiguratorIDext == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  					<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> RuntimeException(String.format(
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  							Messages.InstanceConfigurator_InvalidPluginExtension, iConfiguratorID));
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  				}
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  				<strong class="jxr_keyword">if</strong> (iConfiguratorIDext.equals(iConfiguratorID)) {
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  					<em class="jxr_comment">// TODO: cache returned instance (avoid creating a new instance each time =&gt; more efficient, no need for static attributes)</em>
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  					<strong class="jxr_keyword">final</strong> Object obj = configElement.createExecutableExtension(<span class="jxr_string">"class"</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  					<strong class="jxr_keyword">if</strong> (obj instanceof IInstanceConfigurator) {
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  						<strong class="jxr_keyword">return</strong> (IInstanceConfigurator) obj;
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  					}
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  				}
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  			} <strong class="jxr_keyword">catch</strong> (CoreException exception) {
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  				exception.printStackTrace();
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  			}
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  		}
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  	}
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
